commit a25bfec3aacc34be624a620b00a72719ac03092f
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Nov 17 22:21:24 2021

    Fortran: NULL() is not interoperable
    
    gcc/fortran/ChangeLog:
    
            PR fortran/101329
            * check.c (is_c_interoperable): Reject NULL() as it is not
            interoperable.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/101329
            * gfortran.dg/pr101329.f90: New test.
    
    Co-authored-by: Steven G. Kargl <kargl@gcc.gnu.org>
    (cherry picked from commit 3535be6c6f440909798d1c78e862a657f7adaf63)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index 1ff6b82aaa9..6341756bf3e 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -5175,6 +5175,12 @@ is_c_interoperable (gfc_expr *expr, const char **msg, bool c_loc, bool c_f_ptr)
 {
   *msg = NULL;
 
+  if (expr->expr_type == EXPR_NULL)
+    {
+      *msg = "NULL() is not interoperable";
+      return false;
+    }
+
   if (expr->ts.type == BT_CLASS)
     {
       *msg = "Expression is polymorphic";
diff --git a/gcc/testsuite/gfortran.dg/pr101329.f90 b/gcc/testsuite/gfortran.dg/pr101329.f90
new file mode 100644
index 00000000000..b82210d4e28
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr101329.f90
@@ -0,0 +1,13 @@
+! { dg-do compile }
+! PR fortran/101329 - ICE: Invalid expression in gfc_element_size
+
+program p
+  use iso_c_binding
+  implicit none
+  integer(c_int),     pointer :: ip4
+  integer(c_int64_t), pointer :: ip8
+  print *, c_sizeof (c_null_ptr) ! valid
+  print *, c_sizeof (null ())    ! { dg-error "is not interoperable" }
+  print *, c_sizeof (null (ip4)) ! { dg-error "is not interoperable" }
+  print *, c_sizeof (null (ip8)) ! { dg-error "is not interoperable" }
+end

